<!-- 
 /////////////////// DISCLAIMER ///////////////////////////
 THIS EXAMPLE CODE IS PROVIDED TO YOU ONLY ON AN "AS IS"
 BASIS WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT,
 MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 PAYPAL MAKES NO WARRANTY THAT THE SOFTWARE OR
 DOCUMENTATION WILL BE ERROR-FREE. IN NO EVENT SHALL THE
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ////////////////////////////////////////////////////////////
 */
  -->
<!DOCTYPE html>

<head>
    <!-- Add meta tags for mobile and IE -->
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
</head>

<body>
    <!-- Set up a container element for the button -->
    <div id="paypal-button-container"></div>

    <!-- Include the PayPal JavaScript SDK -->
    <!-- Add 'intent=authorize' if you only want to authorize the payment -->
     <!-- Visit the link below for full list of variables for customizing the SDK -->
    <!-- https://developer.paypal.com/docs/checkout/reference/customize-sdk -->
    <script src="https://www.paypal.com/sdk/js?client-id=AaFb0skm-6sYw90aYngUZGvmrwItG3F4kcAHrbRCEHaQ2kz7kDwSDFV_kwmGYLMbv9ei7B2cAQgfh2nv&currency=GBP"></script>

    <!-- https://developer.paypal.com/docs/checkout/integrate/#  -->
    <script>
        // Render the PayPal button into #paypal-button-container
        paypal.Buttons({

        	//Specify the style of your button
        	//https://developer.paypal.com/docs/checkout/integration-features/customize-button/#
        	style: {
        	    layout:  'vertical',
        	    color:   'gold',
        	    shape:   'rect',
        	    label:   'paypal',
        	    tagline: false
        	  },

            // Set up the transaction
           createOrder: function(data, actions) {
              return actions.order.create({

            	//https://developer.paypal.com/docs/api/orders/v2/#definition-application_context
            	application_context: {
                	//Set if/how you get the shipping address
            		//shipping_preference: 'NO_SHIPPING',
            		shipping_preference: 'SET_PROVIDED_ADDRESS',
            		//shipping_preference: 'GET_FROM_FILE',
            	},
            	payer: {
                    name: {
                      given_name: "PayPal",
                      surname: "Customer"
                    },
                    address: {
                      address_line_1: '123 ABC Street',
                      address_line_2: 'Apt 2',
                      admin_area_2: 'San Jose',
                      admin_area_1: 'CA',
                      postal_code: '95121',
                      country_code: 'US'
                    },
            	},
            	
                purchase_units: [{

            	  //Speciy a description for the payment
                  //description: 'YOUR PAYMENT DESCRIPTION HERE',
                  
                  //If needed you can specify a custom id for the transaction
                  //custom_id: '123456',
                  
                  //Specify an invoice id, this must be unique for each transaction
                  //invoice_id: 'INVOICEID001',
                  
                  //Specify what customers will see on their credit card statements
                  soft_descriptor: 'Roehampton Uni',
                  
                  amount: {
                      
                    //Specify CAPTURE to get funds immediatly or authorize to capture funds later 
                    intent: 'CAPTURE',
                    
                    //Specify the total amount for the transction
                    value: '1.01',
                    
                    //Specify the currency
                    currency_code: 'GBP',
					
                            	//Break the total amount down to its individual componants 
                            	breakdown: {

                                	//Specify the amount for all items and currency to be used
									item_total: {
										currency_code: 'GBP',
										value: '0.01'
									},

									//Specify the total shipping cost and the currency to be used
									shipping: {
										currency_code: 'GBP',
										value: '0.00'
									},

									//Specify the total handling fee and the currency to be used
									handling: {
										currency_code: 'GBP',
										value: '0.50'
									},

									//Specify the total tax and the currency to be used
									tax_total: {
										currency_code: 'GBP',
										value: '0.50'
									},

									//specify the total insuance cost and the currrency to be used
									insurance: {
										currency_code: 'GBP',
										value: '0.00'
									},
									
                    			},
                  },
                    

                    	

            		//Specify the merchant details
              		payee: {
						//email_address:'brain_uk_seller@fake.com'
						merchant_id: 'LKMBPUFVYHVYL'
              		},

              		//Specify the items in the transaction
                  		items: [{
							//Specify the name of the item
							name: 'Donation to XXXXXX',

							//Specify the price of the item and the currency 
							unit_amount: {
								currency_code: 'GBP',
								value: '0.01'
							},

							//Specify the tax of the item and the currency
							tax: {
								currency_code: 'GBP',
								value: '0.50'
							},

							//Specify the quantity of the item
							quantity: '1',

							//Specify a description for the item
							description: 'Donation to XXXXX',

							//Specify an SKU for the item
							//sku: '123',

							//Specify the type of item it is (Can also be PHYSICAL_GOODS)
							//category: 'DIGITAL_GOODS',	
              		}],

                  	
                 

                //Specify the shipping details
              	shipping: {

                  	//specify the full name of the person who the item is to be shipped to
						name: {
							full_name: 'Brian McManus'
						},

						//Specify the address where the items are to be shipped to
						address: {
							address_line_1: '10 Downing Street',
							address_line_2: 'Westminster',
							admin_area_1: 'LONDON',
							admin_area_2: 'London',
							postal_code: 'SW1A 2AA',
							country_code: 'GB',
						},
          		}
          		
                }],
              });
            },

            

            //If shipping costs change depending on the delivery address this is where you can add more vaule to the shipping costs
//             onShippingChange: function(data, actions){

//                 //console.log(data);

// 					//Get the shipping address that they have chosen on PayPal login			
//                 let shipping_address = data.shipping_address;

// 					//Call the file in which you will calculate the new shipping costs and send the new shipping data
//                 fetch("calculate_shipping.php", {
                 
//                 	method: "post",
//                 	body: JSON.stringify({"shipping": shipping_address})
//                 }).then(function(res){
                	
//                 	return res.json();
//                 }).then(function(data){
//                 	console.log(data);
                
// 					  //Define the new shipping amount and add this to the total and patch the new amount to the transaction data
//                   let shippingAmount = 3.00;
//                   let baseOrderAmount = 0.01;
                  
//                   	//If needed you can restrict the countries that you wish to ship to and reject the transaction if it is within the restricted country
//                   if(shipping_address.country_code === "ES"){
//                     return  actions.reject();
//                   }

//                   	//patch the new costs onto the transaction data
//                   return actions.order.patch([
//                       {
//                           op: 'replace',
//                           path: "/purchase_units/@reference_id=='default'/amount",
//                           value: {
//                               currency_code: 'GBP',
//                               value: (baseOrderAmount + shippingAmount).toFixed(2),
//                               breakdown: {
//                                   item_total: {
//                                       currency_code: 'GBP',
//                                       value: baseOrderAmount
//                                   },
//                                   shipping: {
//                                       currency_code: 'GBP',
//                                       value: shippingAmount
//                                   }
//                               }
//                           }
//                       }
//                   ]);

//                 }); 
              
//               },



            // Finalize the transaction
            onApprove: function(data, actions) {
            return actions.order.capture().then(function(details) {

                //If the users payment method does not have the funds then restart the flow and allow thenm to choose another payment method
                //https://developer.paypal.com/docs/checkout/integration-features/funding-failure/
            	if (details.error === 'INSTRUMENT_DECLINED') {
                    return actions.restart();
                  }

            	//Print the entire object
                //console.log(details);

                //Use the details object to get information on the transaction
                alert('Transaction completed by ' + details.payer.name.given_name + " " + details.payer.name.surname
                        + '\n' + details.payer.email_address
                        + '\n at: ' + details.update_time);

              //Show billing address information for the customer only if this is enabled on your account
//              alert("customer billing address: " + "\n"
//                      + details.payer.address.address_line_1 + "\n"
//                      + details.payer.address.address_line_2 + "\n"
//                      + details.payer.address.admin_area_1 + "\n"
//                      + details.payer.address.admin_area_2 + "\n"
//                      + details.payer.address.postal_code + "\n"
//                      + details.payer.address.country_code + "\n");

                //Show shipping address information and phone number for the customer
//                 alert("customer shipping address: " + "\n"
//                         + details.purchase_units[0].shipping.name.full_name + "\n"
//                         + details.purchase_units[0].shipping.address.address_line_1 + "\n"
// 						   + details.purchase_units[0].shipping.address.address_line_2 + "\n"
//                         + details.purchase_units[0].shipping.address.admin_area_1 + "\n"
//                         + details.purchase_units[0].shipping.address.admin_area_2 + "\n"
//                         + details.purchase_units[0].shipping.address.postal_code + "\n"
//                         + details.purchase_units[0].shipping.address.country_code + "\n"
//                         + details.payer.phone.phone_number.national_number + "\n");
                
                // Call your server to save the transaction
                return fetch('/paypal-transaction-complete', {
                  method: 'post',
                  body: JSON.stringify({
                    orderID: data.orderID,
                    payerID: data.payerID,
                    orderDate: details.update_time,
                    billingName: details.payer.name.given_name + " " + details.payer.name.surname,
                    email: details.payer.email_address,
//                     customerName: details.purchase_units[0].shipping.name.full_name,
//                     addressLine1: details.purchase_units[0].shipping.address.address_line_1,
//                     addressLine2: details.purchase_units[0].shipping.address.address_line_2,
//                     adminArea1: details.purchase_units[0].shipping.address.admin_area_1,
//                     adminArea2: details.purchase_units[0].shipping.address.admin_area_2,
//                     postalCode: details.purchase_units[0].shipping.address.postal_code,
//                     countryCode: details.purchase_units[0].shipping.address.country_code,
//                     phoneNumber: details.purchase_units[0].shipping.address.country_code
                  })
                });
              });
            },

            //Listen for the customers address and act on the new information
            //https://developer.paypal.com/docs/checkout/integration-features/shipping-callback/
//             onShippingChange: function(data, actions) {
//                 //Eg. if you only support shipping within the United Kingdom
//                 if (data.shipping_address.country_code !== 'GB') {
//                     return actions.reject();
//                 }

//                 return actions.resolve();
//             },
            
            //https://developer.paypal.com/docs/checkout/integration-features/handle-errors/
            onError: function (err) {
                // Show an error page here, when an error occurs
                alert('An error occurred, please try again');
                console.log(err);
              }
            
          }).render('#paypal-button-container');
    </script>
</body>